#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <time.h>
#include <sys/time.h>

#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#define BUFFER_SIZE 100

int main(int argc, char * argv[]) { 
  int fnum = 0;			  /* number to start on */
  int lnum = 0;			  /* number to end on */
  struct timeval bt;	  	  /* the time before the operation */
  struct timeval at;		  /* the time after the operation */
  struct timezone tz;		  /* time zone information */
  struct hostent * host;	  /* details from gethostbyname */
  char * hostname;		  /* hostname we care about */
  char * result;		  /* ip address it resolves to */

  int i = 0;
  int j = 0;
  int err = 0;

  fnum = atoi(argv[1]);
  lnum = atoi(argv[2]);

  tz.tz_minuteswest = 0;
  tz.tz_dsttime = 0;

  host = (struct hostent *) malloc(sizeof(struct hostent));
  hostname = (char *) malloc(BUFFER_SIZE);
  result = (char *) malloc(BUFFER_SIZE);


  for (i = 0; (i + fnum) <= lnum; i++) { /* run N tests */
    memset(hostname, 0, BUFFER_SIZE);
    memset(result, 0, BUFFER_SIZE);
    memset(host, 0, (int) sizeof(struct hostent));

    snprintf(hostname, 
	100, 
	"fake%d.localnet", 
	(int) (i + fnum));

    gettimeofday(&bt, &tz);
    host = gethostbyname(hostname);
    gettimeofday(&at, &tz);

    /* printf diff, assume gettimeofday to be O(1) */
    printf("%d:%d.%d:%s:%s\n", (i + fnum), 
	(int) (at.tv_sec - bt.tv_sec), 
	(long int) (at.tv_usec - bt.tv_usec),
	hostname,
	inet_ntop(AF_INET, host->h_addr_list[0], result, 100)
	);
  }

  free(hostname);
  free(result);

  return 0;
}
